<template>
    <tippy
        ref="tippy"
        interactive
        :animate-fill="false"
        placement="right"
        reactive
        distant="7"
        theme="hovercard"
        animation="fade"
        trigger="manual"
        arrow="false">

        <template v-slot:trigger>
            <span
                @show="onShow"
                @mouseenter="hover"
                @mouseleave="clearTimer">
                 <slot></slot>
            </span>
        </template>

        <div v-if="loaded" class="hovercard-theme">
            <div class="hovercard">
                <div class="hovercard-background">
                    <img class="hovercard-background__img" :src="user.avatar" alt="">
                </div>

                <div class="hovercard-header">
                    <div class="hovercard-header__container">
                        <div class="hovercard-header__avatar-container">
                            <img class="hovercard-header__avatar-container__img" :src="user.avatar" alt="">
                        </div>

                        <div class="hover-card-header__user-content">

                            <div class="hover-card-header__user-content-info">
                                <div class="hover-card-header__user-content-title">
                                    {{ user.name }}
                                </div>
                                <div class="hover-card-header__user-content-sub-title">
                                    {{ user.role }}
                                </div>
                            </div>

                        </div>
                    </div>
                </div>

                <div class="hovercard-footer"></div>
            </div>
        </div>
    </tippy>
</template>

<script>
    export default {
        name: "UserHovercardComponent",
        data() {
            return {
                user: null,
                loaded: false,
                loading: false,
                timeout: 1000,
                timeoutId: null

            }
        },
        props: [
            'slug'
        ],
        mounted() {
            this.$root.$on('user-card-open', object => {
                if (this._uid !== object._uid) {
                    this.hide()
                }
            })
        },
        methods: {
            onShow () {
                this.$root.$emit('user-card-open', this)
            },
            hover () {
                this.timeoutId = setTimeout(() => {
                    this.load()
                }, this.timeout)
            },
            async load () {
                if (!this.loading) {
                    this.loading = true

                    if (this.loaded) {
                        this.show()
                    } else {
                        try {
                            // Grab info with $http / axios
                            const response = await this.$http.get(`https://kingsgaming.us/api/users/${this.slug}`)

                            this.user = response.data

                            this.loaded = true

                            this.show()
                        } catch (error) {
                            this.loaded = false

                            this.hide()
                        }
                    }
                }
            },
            show () {
                this.loading = false

                this.$refs.tippy.tip.show()
            },

            hide () {
                this.$refs.tippy.tip.hide()
            },

            clearTimer () {
                clearTimeout(this.timeoutId)
               this.hide()
            }
        }
    }
</script>

<style lang="scss">
    .tippy-tooltip.hovercard-theme[data-animatefill] {
        @apply bg-transparent;
    }

    .tippy-tooltip.hovercard-theme {
        background: radial-gradient(circle at top left, rgba(57,57,71, 0.4) 0%, rgba(57,57,71, 0) 60%), rgba(41,41,51, 1);

        @apply shadow-lg w-full max-w-full p-0;
    }

    .tippy-tooltip.navbar-mega-menu-theme .tippy-backdrop {
        @apply bg-neutral-500;
    }

    .tippy-tooltip.navbar-mega-menu-theme[x-placement^='top'] .tippy-arrow {
        @apply border-neutral-500;
    }
    .tippy-tooltip.navbar-mega-menu-theme[x-placement^='bottom'] .tippy-arrow {
        @apply border-neutral-500;
    }
    .tippy-tooltip.navbar-mega-menu-theme[x-placement^='left'] .tippy-arrow {
        @apply border-neutral-500;
    }
    .tippy-tooltip.navbar-mega-menu-theme[x-placement^='right'] .tippy-arrow {
        @apply border-neutral-500;
    }

    .tippy-tooltip.navbar-mega-menu-theme .tippy-roundarrow {
        fill: theme('colors.neutral.500');
    }
</style>
